OGRE-Next: Ogre::v1::PatchSurface Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::PatchSurface Class Reference
Core » LOD

A surface which is defined by curves of some kind to form a patch, e.g. More...

`#include <OgrePatchSurface.h>`

Inheritance diagram for Ogre::v1::PatchSurface:
[legend]

## Public Types
enum | { AUTO_LEVEL = -1 }
| Constant for indicating automatic determination of subdivision level for patches. More...
enum | PatchSurfaceType { PST_BEZIER }
enum | VisibleSide { VS_FRONT , VS_BACK , VS_BOTH }

## Public Member Functions
| PatchSurface ()
| ~PatchSurface ()
void | build (v1::HardwareVertexBufferSharedPtr destVertexBuffer, size_t vertexStart, v1::HardwareIndexBufferSharedPtr destIndexBuffer, size_t indexStart)
| Tells the system to build the mesh relating to the surface into externally created buffers.
void | defineSurface (void *controlPointBuffer, v1::VertexDeclaration *declaration, size_t width, size_t height, PatchSurfaceType pType=PST_BEZIER, size_t uMaxSubdivisionLevel=(size_t) AUTO_LEVEL, size_t vMaxSubdivisionLevel=(size_t) AUTO_LEVEL, VisibleSide visibleSide=VS_FRONT)
| Sets up the surface by defining it's control points, type and initial subdivision level.
Real | getBoundingSphereRadius () const
| Gets the radius of the bounding sphere for this patch, only valid after defineSurface has been called.
const AxisAlignedBox & | getBounds () const
| Gets the bounds of this patch, only valid after calling defineSurface.
void * | getControlPointBuffer () const
size_t | getCurrentIndexCount () const
| Gets the current index count based on the current subdivision level.
size_t | getIndexOffset () const
| Returns the index offset used by this buffer to write data into the buffer.
size_t | getRequiredIndexCount () const
| Based on a previous call to defineSurface, establishes the number of indexes required to hold this patch at the maximum detail level.
size_t | getRequiredVertexCount () const
| Based on a previous call to defineSurface, establishes the number of vertices required to hold this patch at the maximum detail level.
Real | getSubdivisionFactor () const
| Gets the current level of subdivision.
size_t | getVertexOffset () const
| Returns the vertex offset used by this buffer to write data into the buffer.
void | notifyControlPointBufferDeallocated ()
| Convenience method for telling the patch that the control points have been deleted, since once the patch has been built they are not required.
void | setSubdivisionFactor (Real factor)
| Alters the level of subdivision for this surface.

## Detailed Description

A surface which is defined by curves of some kind to form a patch, e.g.

a Bezier patch.

Remarks
  This object will take a list of control points with various assorted data, and will subdivide it into a patch mesh. Currently only Bezier curves are supported for defining the surface, but other techniques such as NURBS would follow the same basic approach.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Constant for indicating automatic determination of subdivision level for patches.

Enumerator
AUTO_LEVEL |

## ◆ PatchSurfaceType

enum Ogre::v1::PatchSurface::PatchSurfaceType

Enumerator
PST_BEZIER | A patch defined by a set of bezier curves.

## ◆ VisibleSide

enum Ogre::v1::PatchSurface::VisibleSide

Enumerator
VS_FRONT | The side from which u goes right and v goes up (as in texture coords).
VS_BACK | The side from which u goes right and v goes down (reverse of texture coords).
VS_BOTH | Both sides are visible - warning this creates 2x the number of triangles and adds extra overhead for calculating normals.

## Constructor & Destructor Documentation

## ◆ PatchSurface()

Ogre::v1::PatchSurface::PatchSurface | ( |  | ) |

## ◆ ~PatchSurface()

Ogre::v1::PatchSurface::~PatchSurface | ( |  | ) |

## Member Function Documentation

## ◆ build()

void Ogre::v1::PatchSurface::build | ( | v1::HardwareVertexBufferSharedPtr | destVertexBuffer,
|  | size_t | vertexStart,
|  | v1::HardwareIndexBufferSharedPtr | destIndexBuffer,
|  | size_t | indexStart )

Tells the system to build the mesh relating to the surface into externally created buffers.

Remarks
  The VertexDeclaration of the vertex buffer must be identical to the one passed into defineSurface. In addition, there must be enough space in the buffer to accommodate the patch at full detail level; you should call getRequiredVertexCount and getRequiredIndexCount to determine this. This method does not create an internal mesh for this patch and so getMesh will return null if you call it after building the patch this way.

Parameters

  destVertexBuffer | The destination vertex buffer in which to build the patch.
  vertexStart | The offset at which to start writing vertices for this patch
  destIndexBuffer | The destination index buffer in which to build the patch.
  indexStart | The offset at which to start writing indexes for this patch

## ◆ defineSurface()

void Ogre::v1::PatchSurface::defineSurface | ( | void * | controlPointBuffer,
|  | v1::VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | PatchSurfaceType | pType = PST_BEZIER,
|  | size_t | uMaxSubdivisionLevel = (size_t) AUTO_LEVEL,
|  | size_t | vMaxSubdivisionLevel = (size_t) AUTO_LEVEL,
|  | VisibleSide | visibleSide = VS_FRONT )

Sets up the surface by defining it's control points, type and initial subdivision level.

Remarks
  This method initialises the surface by passing it a set of control points. The type of curves to be used are also defined here, although the only supported option currently is a bezier patch. You can also specify a global subdivision level here if you like, although it is recommended that the parameter is left as AUTO_LEVEL, which means the system decides how much subdivision is required (based on the curvature of the surface)

Parameters

  controlPointBuffer | A pointer to a buffer containing the vertex data which defines control points of the curves rather than actual vertices. Note that you are expected to provide not just position information, but potentially normals and texture coordinates too. The format of the buffer is defined in the VertexDeclaration parameter
  declaration | VertexDeclaration describing the contents of the buffer. Note this declaration must only draw on buffer source 0!
  width | Specifies the width of the patch in control points.
  height | Specifies the height of the patch in control points.
  pType | The type of surface - currently only PST_BEZIER is supported
  uMaxSubdivisionLevel,vMaxSubdivisionLevel | If you want to manually set the top level of subdivision, do it here, otherwise let the system decide.
  visibleSide | Determines which side of the patch (or both) triangles are generated for.

References AUTO_LEVEL, PST_BEZIER, and VS_FRONT.

## ◆ getBoundingSphereRadius()

Real Ogre::v1::PatchSurface::getBoundingSphereRadius | ( |  | ) | const

Gets the radius of the bounding sphere for this patch, only valid after defineSurface has been called.

## ◆ getBounds()

const AxisAlignedBox & Ogre::v1::PatchSurface::getBounds | ( |  | ) | const

Gets the bounds of this patch, only valid after calling defineSurface.

## ◆ getControlPointBuffer()

void * Ogre::v1::PatchSurface::getControlPointBuffer | ( |  | ) | const
| inline

## ◆ getCurrentIndexCount()

size_t Ogre::v1::PatchSurface::getCurrentIndexCount | ( |  | ) | const

Gets the current index count based on the current subdivision level.

## ◆ getIndexOffset()

size_t Ogre::v1::PatchSurface::getIndexOffset | ( |  | ) | const
| inline

Returns the index offset used by this buffer to write data into the buffer.

## ◆ getRequiredIndexCount()

size_t Ogre::v1::PatchSurface::getRequiredIndexCount | ( |  | ) | const

Based on a previous call to defineSurface, establishes the number of indexes required to hold this patch at the maximum detail level.

Remarks
  This is useful when you wish to build the patch into external vertex / index buffers.

## ◆ getRequiredVertexCount()

size_t Ogre::v1::PatchSurface::getRequiredVertexCount | ( |  | ) | const

Based on a previous call to defineSurface, establishes the number of vertices required to hold this patch at the maximum detail level.

Remarks
  This is useful when you wish to build the patch into external vertex / index buffers.

## ◆ getSubdivisionFactor()

Real Ogre::v1::PatchSurface::getSubdivisionFactor | ( |  | ) | const

Gets the current level of subdivision.

## ◆ getVertexOffset()

size_t Ogre::v1::PatchSurface::getVertexOffset | ( |  | ) | const
| inline

Returns the vertex offset used by this buffer to write data into the buffer.

## ◆ notifyControlPointBufferDeallocated()

void Ogre::v1::PatchSurface::notifyControlPointBufferDeallocated | ( |  | ) |
| inline

Convenience method for telling the patch that the control points have been deleted, since once the patch has been built they are not required.

## ◆ setSubdivisionFactor()

void Ogre::v1::PatchSurface::setSubdivisionFactor | ( | Real | factor | ) |

Alters the level of subdivision for this surface.

Remarks
  This method changes the proportionate detail level of the patch; since the U and V directions can have different subdivision levels, this method takes a single Real value where 0 is the minimum detail (the control points) and 1 is the maximum detail level as supplied to the original call to defineSurface.

The documentation for this class was generated from the following file:

- OgrePatchSurface.h